/*
 * Created on Feb 13, 2006
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package de.desy.tine.servlets;
import de.desy.tine.client.*;
import de.desy.tine.dataUtils.*;
import de.desy.tine.definitions.*;
import de.desy.tine.queryUtils.*;

import java.io.*;
import java.util.Date;
import java.util.LinkedHashMap;
import java.util.Set;
import javax.servlet.*;
import javax.servlet.http.*;

public class WebRepeater extends HttpServlet
{
  private static final long serialVersionUID = -3016747792664322588L;
  ServletCallback lnkCb = new ServletCallback();
  Date date = new Date();
  private LinkedHashMap linkTable = new LinkedHashMap(256);
  public class ServletLink
  {
    TLink lnk = null;
    TDataType dout = null;
    String units = "";
    String description = "";
    long lastAccess = 0;
  }
  public class ServletCallback implements TLinkCallback
  {
    public void callback(TLink link)
    {
      String key = link.getFullDeviceName() + "/" + link.getProperty();
      if (linkTable.containsKey(key))
      {
        ServletLink slnk = (ServletLink)linkTable.get(key);
        slnk.dout = link.getOutputDataObject();
        if (System.currentTimeMillis() > slnk.lastAccess + 600000)
        { // no one has accessed this in the last 10 minutes => remove it
          link.cancel();
          linkTable.remove(key);
        }
      }
    }    
  }
  public void init() throws ServletException
  {
    // ??
  }
  public void destroy() 
  {
    // ??
  }
  
  public String getDorisPayload()
  {
    String payload = "";
    String link;
    
    link = "/DORIS/DORISDATA/#0/DoDCCur";
    payload += getLinkPayload(link) + "<p>";
    link = "/DORIS/DORISDATA/#0/DoDCTau";
    payload += getLinkPayload(link) + "<p>";
    link = "/DORIS/DORISDATA/#0/DoEnergy";
    payload += getLinkPayload(link) + "<p>";
    link = "/DORIS/DORISDATA/#0/DoSTATE";
    payload += getLinkPayload(link) + "<p>";
    link = "/DORIS/DORISDATA/#0/DoTVText";
    payload += getLinkPayload(link) + "<p>";
    link = "/DORIS/DORISDATA/#0/DoBLBeamPos.X";
    payload += getLinkPayload(link) + "<p>";
    link = "/DORIS/DORISDATA/#0/DoBLBeamPos.Y";
    payload += getLinkPayload(link) + "<p>";
    link = "/DORIS/DORISDATA/#0/DoBLMonPos.X";
    payload += getLinkPayload(link) + "<p>";
    link = "/DORIS/DORISDATA/#0/DoBLMonPos.Y";
    payload += getLinkPayload(link) + "<p>";
    
    return payload;
  }
  public String getDesyPayload()
  {
    String payload = "";
    String link;

    link = "/DESY2/DESYDATA/#0/L2Cur";
    payload += getLinkPayload(link) + "<p>";
    link = "/DESY2/DESYDATA/#0/L2Energy";
    payload += getLinkPayload(link) + "<p>";
    link = "/DESY2/DESYDATA/#0/L2STATE";
    payload += getLinkPayload(link) + "<p>";
    link = "/DESY2/DESYDATA/#0/L3Momentum";
    payload += getLinkPayload(link) + "<p>";
    link = "/DESY2/DESYDATA/#0/L3Energy";
    payload += getLinkPayload(link) + "<p>";
    link = "/DESY2/DESYDATA/#0/L3STATE";
    payload += getLinkPayload(link) + "<p>";
    
    link = "/DESY2/DESYDATA/#0/D2Cur";
    payload += getLinkPayload(link) + "<p>";
    link = "/DESY2/DESYDATA/#0/D2Energy";
    payload += getLinkPayload(link) + "<p>";
    link = "/DESY2/DESYDATA/#0/D2STATE";
    payload += getLinkPayload(link) + "<p>";
    link = "/DESY2/DESYDATA/#0/D3IBottom";
    payload += getLinkPayload(link) + "<p>";
    link = "/DESY2/DESYDATA/#0/D3ITop";
    payload += getLinkPayload(link) + "<p>";
    link = "/DESY2/DESYDATA/#0/D3EBottomN";
    payload += getLinkPayload(link) + "<p>";
    link = "/DESY2/DESYDATA/#0/D3ETopN";
    payload += getLinkPayload(link) + "<p>";
    link = "/DESY2/DESYDATA/#0/D3STATE";
    payload += getLinkPayload(link) + "<p>";
        
    return payload;
  }
  public String getPetraPayload()
  {
    String payload = "";
    String link;
    
    link = "/PETRA/PETRADATA/#0/PETYPE";
    payload += getLinkPayload(link) + "<p>";
    link = "/PETRA/PETRADATA/#0/PEDCCur";
    payload += getLinkPayload(link) + "<p>";
    link = "/PETRA/PETRADATA/#0/PEDCTau";
    payload += getLinkPayload(link) + "<p>";
    link = "/PETRA/PETRADATA/#0/PEMAGEN";
    payload += getLinkPayload(link) + "<p>";
    link = "/PETRA/PETRADATA/#0/PEESTATE";
    payload += getLinkPayload(link) + "<p>";
    link = "/PETRA/PETRADATA/#0/PEPSTATE";
    payload += getLinkPayload(link) + "<p>";
    
    return payload;
  }
  public String getHeraPayload()
  {
    String payload = "";
    String link;
    
    link = "/HERA/HERADATA/#0/HEDCCur";
    payload += getLinkPayload(link) + "<p>";
    link = "/HERA/HERADATA/#0/HEDCTau";
    payload += getLinkPayload(link) + "<p>";
    link = "/HERA/HERADATA/#0/HEMAGEN";
    payload += getLinkPayload(link) + "<p>";
    link = "/HERA/HERADATA/#0/HESTATE";
    payload += getLinkPayload(link) + "<p>";
    link = "/HERA/HERADATA/#0/HPDCCur";
    payload += getLinkPayload(link) + "<p>";
    link = "/HERA/HERADATA/#0/HPDCTau";
    payload += getLinkPayload(link) + "<p>";
    link = "/HERA/HERADATA/#0/HPMAGEN";
    payload += getLinkPayload(link) + "<p>";
    link = "/HERA/HERADATA/#0/HPSTATE";
    payload += getLinkPayload(link) + "<p>";
    
    return payload;
  }
  public String getLinkPayload(String devNameAndProperty)
  {
    TLink lnk = null;
    ServletLink slnk;
    String payload = null;

    if (!linkTable.containsKey(devNameAndProperty))
    { // start a new link !
      slnk = new ServletLink();
      lnk = new TLink(devNameAndProperty);
      if (lnk != null)
      {
        slnk.lnk = lnk;
        XPropertyQuery[] xpqs = TQuery.getDevicePropertyInformationX(lnk.getContext(),lnk.getDeviceServer(),lnk.getDeviceName(),lnk.getProperty());
        if (xpqs != null) 
        {
          slnk.units = new String(xpqs[0].prpUnits);
          if (slnk.units.compareTo("none") == 0) slnk.units = "";
          slnk.description = new String(xpqs[0].prpDescription);
        }
        slnk.lnk.setArrayDelimiter(",");
        slnk.lastAccess = System.currentTimeMillis();
        slnk.lnk.attach(TMode.CM_POLL|TMode.CM_WAIT,lnkCb,1000);
        slnk.dout = slnk.lnk.getOutputDataObject();
      }
      linkTable.put(devNameAndProperty,slnk);
    }
    else
    { // I've already got the link ...
      slnk = (ServletLink)linkTable.get(devNameAndProperty);
    }
    String tag = slnk.description;
    if (tag.length() == 0) tag = devNameAndProperty;
    date.setTime(slnk.dout.getDataTimeStamp());
    slnk.lastAccess = System.currentTimeMillis();
    payload =  new String("<BIG>" + 
        tag + " = " + slnk.dout.toString() + " " + slnk.units + 
        " at " + date.toString() + "</BIG>");
    
    return payload;
  }
  private String parseQueryPayloadString(String banner,String[] strArray)
  {
    String s = "<BIG> " + banner;
    for (int i=0; i<strArray.length; i++) 
    {
      s += "<li>" + strArray[i] + "</li>";
    }    
    s += "</BIG>";
    return s;
  }
  public String getQueryPayload(String context,String server,String device,String property)
  {
    boolean contextKnown = false;
    boolean serverKnown = false;
    boolean deviceKnown = false;
    boolean propertyKnown = false;
    if (context != null && context.length() != 0) contextKnown = true;
    if (server != null && server.length() != 0) serverKnown = true;
    if (device != null && device.length() != 0) deviceKnown = true;
    if (property != null && property.length() != 0) propertyKnown = true;
    if (!contextKnown && !serverKnown) 
      return parseQueryPayloadString("Available Contexts",TQuery.getContexts());
    if (contextKnown && !serverKnown)
      return parseQueryPayloadString("Device Servers for Context " + context,TQuery.getDeviceServers(context));
    if (contextKnown && serverKnown && !deviceKnown && !propertyKnown)
      return parseQueryPayloadString("Properties for /" + context + "/" + server,TQuery.getDeviceProperties(context,server,"#0"));
    return "";
  }
  public String getQueryLinksPayload()
  {
    String payload = "<BIG> Currently active Links : ";
    Set keys = linkTable.keySet();
    if (keys == null)
    {
      payload += "no links available";
    }
    else
    {
      Object[] lnks = keys.toArray();
      if (lnks != null)
      {
        for (int i=0; i<lnks.length; i++) payload += "<li>" + (String)lnks[i] + "</li>";
      }
    }
    payload += "</BIG>";
    return payload;
  }
  public void doGet(HttpServletRequest req, HttpServletResponse res)
    throws ServletException, IOException
    {
      boolean doMonitor = false;
      res.setContentType("text/html");
      if(req.getMethod().equals("HEAD")) return;
      PrintWriter out = res.getWriter();
      String payload = null;
      
      String setName = req.getParameter("setname");
      String monitorNameAndProperty = req.getParameter("monitorname");
      String devNameAndProperty = req.getParameter("linkname");
      String contextName = req.getParameter("contextname");
      if (contextName != null && contextName.length() == 0) contextName = null; // not given ...
      String serverName = req.getParameter("servername");
      if (serverName != null && serverName.length() == 0) serverName = null; // not given ...
      String deviceName = req.getParameter("devicename");
      if (deviceName != null && deviceName.length() == 0) deviceName = null; // not given ...
      String propertyName = req.getParameter("propertyname");
      if (propertyName != null && propertyName.length() == 0) propertyName = null; // not given ...
      
      String queryActive = req.getParameter("queryactive");
      
      if (contextName != null && serverName != null && deviceName != null && propertyName != null)
      {
        devNameAndProperty = "/" + contextName + "/" + serverName + 
                             "/" + deviceName + "/" + propertyName; 
      }
      if (monitorNameAndProperty != null && monitorNameAndProperty.length() != 0)
      {
        doMonitor = true;
        devNameAndProperty = monitorNameAndProperty; 
      }
      
      if (queryActive != null) 
      {
        payload = getQueryLinksPayload();
      }
      else if (devNameAndProperty != null && devNameAndProperty.length() != 0)
      {
        payload = getLinkPayload(devNameAndProperty);      
        if (doMonitor) res.setHeader("Refresh","1");
      }
      else if (setName != null && setName.length() != 0)
      {
        if (setName.toUpperCase().compareTo("HERA") == 0)
          payload = getHeraPayload();
        else if (setName.toUpperCase().compareTo("PETRA") == 0)
          payload = getPetraPayload();
        else if (setName.toUpperCase().compareTo("DORIS") == 0)
          payload = getDorisPayload();
        else if (setName.toUpperCase().compareTo("DESY") == 0)
          payload = getDesyPayload();
        else
          payload = getDorisPayload();
      }
      else
      {
        payload = getQueryPayload(contextName,serverName,deviceName,propertyName);
      }
      if (payload == null) payload = "no operation";
      out.println(payload);              
    }
  public String getServletInfo()
  {
    return "Web Repeater for TINE calls";
  }
}
